<?php
/**
 * Created by PhpStorm.
 * User: roc
 * Date: 2020/4/10
 * Time: 19:24
 */

namespace kwy\lepass\lib\ad;
use kwy\util\http\CurlHttp;

class Ad
{
    /**
     * @var CurlHttp
     */
    private $httpClient;

    private $appKey = "1da3e6f334804d18bad44748a8e0a0ec";   //流量方appKey 请联系商务人员获取

    private $adId = ""; //广告id

    private $apiVersion = "1.0.0"; //乐聚量api版本号

    private $baseUrl = "https://ads.lejuliang.com/getAd";   //基础url

    private $mcc = "10001";   //行业

    /**
     * 设置流量方秘钥
     * @author roc
     * @datetime:2020/4/10 19:31
     * @param string $appKey 流量方appKey
     * @return $this
     */
    public function setAppKey($appKey){
        $this->appKey = $appKey;
        return $this;
    }

    /**
     * 获取流量方秘钥
     * @author roc
     * @datetime:2020/4/10 19:31
     * @return string
     */
    public function getAppKey(){
        return $this->appKey;
    }

    /**
     * 设置广告id
     * @author roc
     * @datetime:2020/4/10 19:31
     * @param string $adId 流量方appKey
     * @return $this
     */
    public function setAdId($adId){
        $this->adId = $adId;
        return $this;
    }

    /**
     * 获取广告id
     * @author roc
     * @datetime:2020/4/10 19:31
     * @return string
     */
    public function getAdId(){
        return $this->adId;
    }

    /**
     * 设置乐聚量api版本号
     * @author roc
     * @datetime:2020/4/10 19:31
     * @param string $apiVersion 乐聚量api 版本号
     * @return $this
     */
    public function setApiVersion($apiVersion){
        $this->apiVersion = $apiVersion;
        return $this;
    }

    /**
     * 获取乐聚量api版本号
     * @author roc
     * @datetime:2020/4/10 19:31
     * @return string
     */
    public function getApiVersion(){
        return $this->apiVersion;
    }

    /**
     * 设置基础url
     * @author roc
     * @datetime:2020/4/10 19:31
     * @param string $baseUrl 基础url
     * @return $this
     */
    public function setBaseUrl($baseUrl){
        $this->baseUrl = $baseUrl;
        return $this;
    }

    /**
     * 获取基础url
     * @author roc
     * @datetime:2020/4/10 19:31
     * @return string
     */
    public function getBaseUrl(){
        return $this->baseUrl;
    }

    /**
     * 设置行业，此项建议填写流量所属行业，对接时请流量方提供行业分类表，我方后台做映射转换
     * @author roc
     * @datetime:2020/4/10 20:02
     * @param $mcc
     * @return $this
     */
    public function setMcc($mcc){
        $this->mcc = $mcc;
        return $this;
    }

    /**
     * 获取行业
     * @author roc
     * @datetime:2020/4/10 19:31
     * @return string
     */
    public function getMcc(){
        return $this->mcc;
    }

    /**
     * 获取广告
     * @author roc
     * @datetime:2020/4/10 20:15
     * @param string $screen_width 屏幕分辨率宽度，单位为px
     * @param string $screen_height 屏幕分辨率高度，单位为px
     * @return bool|mixed|string
     * @throws \Exception
     */
    public function getAd($screen_width='',$screen_height=''){
        $url = $this->baseUrl."?";

        $data = [
            "app_key" => $this->appKey,
            "adid" => $this->adId,
            "api_version" => $this->apiVersion,
            "transaction_amount" => "100",
            "third_merchant_id" => "42",  //商户自有id
            "mcc" => $this->mcc,
            "screen_width"=> $screen_width, //屏幕分辨率宽度，单位为px
            "screen_height" => $screen_height    //屏幕分辨率高度，单位为px
        ];
        foreach($data as $k=>$v){
            $url .= $k."=".$v."&";
        }

        $url = substr($url,0,-1);
        $result = $this->getHttpClient()->get($url);
        if(empty($result)){
            return [];
        }else{
            return json_decode($result,true);
        }
        return $result;
    }

    /**
     * 广告展示上报
     * @author roc
     * @datetime:2020/4/11 12:01
     * @param $url
     * @return array|bool|mixed|string
     * @throws \Exception
     */
    public function impressionAd($url){
        $result = $this->getHttpClient()->get($url);
        if(empty($result)){
            return [];
        }else{
            return json_decode($result,true);
        }
        return $result;
    }

    /**
     * 获取http请求客户端
     * @author roc
     * @return CurlHttp
     */
    public function getHttpClient(){
        if (empty($this->httpClient)){
            $this->httpClient = new CurlHttp();
            //$this->httpClient->setProxy('127.0.0.1:8888');
            $this->httpClient->setContentType('application/json');
        }
        return $this->httpClient;
    }


    /**
     * 设置代理
     * @author roc
     * @datetime:2019/12/8 14:37
     * @param $proxy
     * @return $this
     */
    public function setProxy($proxy){
        $this->getHttpClient()->setProxy($proxy);
        return $this;
    }

    /**
     * 设置请求的user_agent
     * @author roc
     * @datetime:2020/4/11 10:58
     * @param $userAgent
     * @return $this
     */
    public function setUserAgent($userAgent){
        $this->getHttpClient()->setUserAgent($userAgent);
        return $this;
    }
}